#include <MsTimer2.h>

//-------------------------------------
#define STATE_ENTRY \
static unsigned int sm_time = 0; \
static unsigned char sm_state = 0; \
unsigned char sm_localstate; \
unsigned char sm_repeat; \
if(sm_time > 0) sm_time--; \
if(sm_time == 0) \
{ \
   do \
   { \
      sm_localstate = 0; \
      sm_state++; \
      sm_repeat = 0;
//-------------------------------------   
   
//-------------------------------------   
#define STATE_DURATION(x) \
sm_localstate++; \
if(sm_localstate == sm_state) \
{ \
   sm_time = x;
//-------------------------------------

//-------------------------------------
#define STATE_END \
break; }
//-------------------------------------

//-------------------------------------
#define STATE_EXIT \
   sm_state = 0; \
   sm_repeat = 1; \
} while(sm_repeat); }
//-------------------------------------

//-------------------------------------
#define STATE_SET(x) \
   sm_state = x;
//-------------------------------------


#if defined (__AVR_ATmega168__) || defined (__AVR_ATmega48__) || defined (__AVR_ATmega88__) || defined (__AVR_ATmega328P__) || (__AVR_ATmega1280__)
	#define MSTICK_INT_DISABLE  TIMSK2 &= ~(1<<TOIE2);
#elif defined (__AVR_ATmega128__)
	#define MSTICK_INT_DISABLE  TIMSK &= ~(1<<TOIE2);
#elif defined (__AVR_ATmega8__)
	#define MSTICK_INT_DISABLE  TIMSK &= ~(1<<TOIE2);
#endif


#if defined (__AVR_ATmega168__) || defined (__AVR_ATmega48__) || defined (__AVR_ATmega88__) || defined (__AVR_ATmega328P__) || (__AVR_ATmega1280__)
	#define MSTICK_INT_ENABLE  TIMSK2 |= (1<<TOIE2);
#elif defined (__AVR_ATmega128__)
	#define MSTICK_INT_ENABLE  TIMSK |= (1<<TOIE2);
#elif defined (__AVR_ATmega8__)
	#define MSTICK_INT_ENABLE  TIMSK |= (1<<TOIE2);
#endif


void init_system(void)
{
  cli();
  MsTimer2::set(1, ms_tick); // 1ms period
  MsTimer2::start();
  sei();
}


void ms_tick(void)
{
  MSTICK_INT_DISABLE;
  sei();
  
  lichteffektsteuerung();
  
  cli();
  MSTICK_INT_ENABLE;
}

