#define LED_AK1 11
#define LED_AK1_AUS digitalWrite(LED_AK1, LOW)
#define LED_AK1_EIN digitalWrite(LED_AK1, HIGH)
#define LED_AK1_DIR_OUT pinMode(LED_AK1, OUTPUT)

#define LED_AK2 12
#define LED_AK2_AUS digitalWrite(LED_AK2, LOW)
#define LED_AK2_EIN digitalWrite(LED_AK2, HIGH)
#define LED_AK2_DIR_OUT pinMode(LED_AK2, OUTPUT)

#define AK_KONTAKT A3
#define AK_KONTAKT_AKTIV (digitalRead(AK_KONTAKT) == LOW)
#define AK_PULLUP digitalWrite(AK_KONTAKT, HIGH)


void init_andreaskreuz(void)
{
  AK_PULLUP;
  LED_AK1_AUS;
  LED_AK1_DIR_OUT;
  LED_AK2_AUS;
  LED_AK2_DIR_OUT;
}



void andreaskreuz(void)
{
  static unsigned char repeat = 0;
  
  STATE_ENTRY;

  STATE_DURATION(10); // Auslösekontakt prüfen
  LED_AK2_AUS;
  LED_AK1_AUS;
  if(AK_KONTAKT_AKTIV)
  {
    repeat = 10-1;
  }
  else
  {
    STATE_SET(0);
  }
  STATE_END;
  
  STATE_DURATION(500); // AK1: ein AK2: aus
  LED_AK2_AUS;
  LED_AK1_EIN;
  STATE_END;
  
  STATE_DURATION(500); // AK1: aus AK2: ein
  LED_AK1_AUS;
  LED_AK2_EIN;
  if(repeat)
  {
    repeat--;
    STATE_SET(1);
    if(AK_KONTAKT_AKTIV)
    {
       repeat = 10-1;
    }
  }
  STATE_END;

  STATE_EXIT;
}

